"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mutation_1 = require("./mutation");
const metadata_1 = require("../constants/metadata");
class Container {
    constructor(params) {
        this.params = params;
        this.datas = {};
        this.mutation = new mutation_1.Mutation();
        this.init();
        this.insert();
    }
    init() {
        this.params.forEach(handler => {
            const type = Reflect.getMetadata(metadata_1.metadata.HANDLER_IDENTIFIER, handler);
            this.datas[type] = (this.datas[type] || []).concat([handler]);
        });
    }
    insert() {
        this.mutation.devour({
            commands: this.datas[metadata_1.handlers.COMMAND] || [],
            options: this.datas[metadata_1.handlers.OPTION] || [],
            missing: this.datas[metadata_1.handlers.MISSING] || [],
            majors: this.datas[metadata_1.handlers.MAJOR] || [],
        });
    }
}
exports.Container = Container;
