"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const metadata_1 = require("../constants/metadata");
exports.commandsToDatas = (commands = []) => {
    return commands.map(fn => Reflect.getMetadata(metadata_1.metadata.COMMAND_IDENTIFIER, fn));
};
exports.optionsToDatas = (options) => {
    return options.map(fn => Reflect.getMetadata(metadata_1.metadata.OPTION_IDENTIFIER, fn));
};
exports.optionsToKeyValue = (params = []) => {
    if (!params || !params.length)
        return {};
    return params.reduce((pre, current) => {
        const name = `--${current.name}`;
        const alias = current.alias ? { [`-${current.alias}`]: name } : {};
        return Object.assign({}, pre, {
            [name]: current.type,
        }, alias);
    }, {});
};
exports.removeHyphen = (key) => {
    return key.replace(/^[-]+/, '');
};
